resource_rules:
  issues:
    rules:
      - name: Add  ~"workspaces-workflow::unprioritized" to any issue that has the ~"Category:Workspaces" label and does not have any existing "workspaces-workflow::*" labels
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
          forbidden_labels:
            - "workspaces-workflow::unprioritized"
            - "workspaces-workflow::prioritized"
            - "workspaces-workflow::done"
            - "workspaces-workflow::ignore"
        actions:
          labels:
            - workspaces-workflow::unprioritized
      - name: Issues with a specific milestone but do not have the ~"workspaces-workflow::prioritized" label should have the milestone automatically set back to %"Next 1-3 releases"
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
          forbidden_labels:
            - "workspaces-workflow::prioritized"
            - "workspaces-workflow::ignore"
          milestone: any
          ruby: milestone.title.match?(/\A\d+\.\d+\z/)
        actions:
          comment: |
            {{author}} this issue had a specific milestone but did not have the ~"workspaces-workflow::prioritized" label, so the milestone has been set back to %"Next 1-3 releases".

            /milestone %"Next 1-3 releases"
      - name: Issues with a specific milestone but no weight should have the milestone automatically set back to %"Next 1-3 releases"
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
          forbidden_labels:
            - "workspaces-workflow::ignore"
          milestone: any
          ruby: milestone.title.match?(/\A\d+\.\d+\z/)
          weight: none
        actions:
          comment: |
            {{author}} this issue had a specific milestone but did not have a weight, so the milestone has been set back to %"Next 1-3 releases".

            /milestone %"Next 1-3 releases"
      - name: Issues with a specific milestone but no iteration should have the milestone automatically set back to %"Next 1-3 releases"
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
          forbidden_labels:
            - "workspaces-workflow::ignore"
          milestone: any
          ruby: milestone.title.match?(/\A\d+\.\d+\z/)
          iteration: none
        actions:
          comment: |
            {{author}} this issue had a specific milestone but did not have a iteration, so the milestone has been set back to %"Next 1-3 releases".

            /milestone %"Next 1-3 releases"
      - name: Every Issue with the ~"Category:Workspaces" label and that is closed should have the ~"workspaces-workflow::done" label.
        conditions:
          state: closed
          labels:
            - "Category:Workspaces"
          forbidden_labels:
            - "workspaces-workflow::done"
            - "workspaces-workflow::ignore"
        actions:
          comment: |
            {{author}} this issue had the ~"Category:Workspaces" label and was closed. The ~"workspaces-workflow::done" label has been applied.
          labels:
            - "workspaces-workflow::done"
      - name: Issues with the ~"workspaces-workflow::unprioritized" label but with no GitLab workflow label should have the ~"workflow::refinement" label assigned
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
            - "workspaces-workflow::unprioritized"
          forbidden_labels:
            # TODO: We should have a labels filter using a regex to avoid hardcoding these
            - "workflow::awaiting security release"
            - "workflow::blocked"
            - "workflow::complete"
            - "workflow::design"
            - "workflow::feature-flagged"
            - "workflow::in dev"
            - "workflow::in review"
            - "workflow::planning breakdown"
            - "workflow::problem validation"
            - "workflow::production"
            - "workflow::ready for design"
            - "workflow::ready for development"
            - "workflow::refinement"
            - "workflow::scheduling"
            - "workflow::solution validation"
            - "workflow::start"
            - "workflow::validation backlog"
            - "workflow::verification"
            - "workflow::complete"
            - "workspaces-workflow::ignore"
        actions:
          comment: |
            {{author}} this issue had the ~"workspaces-workflow::unprioritized" label but no GitLab workflow label. The ~"workflow::refinement" label has been applied.
          labels:
            - workflow::refinement
      - name: Unstarted issues with the ~"workspaces-workflow::prioritized" label that also have the ~"refined" label should get the ~"workflow::ready for development" label assigned
        conditions:
          state: opened
          labels:
            - "Category:Workspaces"
            - "workspaces-workflow::prioritized"
            - refined
          forbidden_labels:
            - "workflow::ready for development"
            - "workspaces-workflow::ignore"
        actions:
          comment: |
            {{author}} this unstarted issue with the ~"workspaces-workflow::prioritized" label also had the ~"refined" label. The ~"workflow::ready for development" label has been applied.
          labels:
            - workflow::ready for development
